VERSION 2.00
Begin Form FrmFigure 
   AutoRedraw      =   -1  'True
   Caption         =   "FrmFigure"
   Height          =   2550
   KeyPreview      =   -1  'True
   Left            =   420
   LinkTopic       =   "FrmFigure"
   MDIChild        =   -1  'True
   ScaleHeight     =   2145
   ScaleWidth      =   3330
   Top             =   2010
   Width           =   3450
   Begin PictureBox Picture1 
      BackColor       =   &H00C0C0C0&
      Height          =   255
      Left            =   3000
      ScaleHeight     =   225
      ScaleWidth      =   225
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   1800
      Width           =   255
   End
   Begin HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   500
      Left            =   0
      SmallChange     =   50
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   1800
      Width           =   3015
   End
   Begin VScrollBar VScroll1 
      Height          =   1815
      LargeChange     =   500
      Left            =   3000
      SmallChange     =   50
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   255
   End
   Begin PictureBox PicMain 
      AutoRedraw      =   -1  'True
      Height          =   1815
      Left            =   0
      ScaleHeight     =   1785
      ScaleWidth      =   2985
      TabIndex        =   3
      Top             =   0
      Width           =   3015
      Begin PictureClip PicClip 
         Location        =   "1215,1215,120,1440"
      End
      Begin Shape Region 
         BorderStyle     =   3  '_
         DrawMode        =   6  'Invert
         Height          =   1215
         Left            =   120
         Top             =   120
         Visible         =   0   'False
         Width           =   1215
      End
   End
End
Option Explicit

Const CHILDWINDOW_DEFAULT_STATE = NORMAL

'{^Ƃ̍W
Dim Rs_X As Single
Dim Rs_Y As Single

'W\̂߂PicMain.ScaleMode̐ݒɕKv
Dim OriginX As Single
Dim OriginY As Single
Dim ZoomFactorX As Single
Dim ZoomFactorY As Single

Function F_Get_Real_X (X As Single) As Long
    F_Get_Real_X = CLng((X - OriginX) / ZoomFactorX)
End Function

Function F_Get_Real_Y (Y As Single) As Long
    F_Get_Real_Y = CLng((PicMain.Height - Y - OriginY) / ZoomFactorY)
End Function

Sub Form_KeyDown (KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
    Case KEY_LEFT
        If HScroll1.Visible = True Then
            If HScroll1.Value + ((Shift <> SHIFT_MASK) * HScroll1.SmallChange + (Shift = SHIFT_MASK) * HScroll1.LargeChange) < HScroll1.Min Then
                HScroll1.Value = HScroll1.Min
            Else
                HScroll1.Value = HScroll1.Value + ((Shift <> SHIFT_MASK) * HScroll1.SmallChange + (Shift = SHIFT_MASK) * HScroll1.LargeChange)
            End If
        End If
    Case KEY_RIGHT
        If HScroll1.Visible = True Then
            If HScroll1.Value - ((Shift <> SHIFT_MASK) * HScroll1.SmallChange + (Shift = SHIFT_MASK) * HScroll1.LargeChange) > HScroll1.Max Then
                HScroll1.Value = HScroll1.Max
            Else
                HScroll1.Value = HScroll1.Value - ((Shift <> SHIFT_MASK) * HScroll1.SmallChange + (Shift = SHIFT_MASK) * HScroll1.LargeChange)
            End If
        End If
    Case KEY_UP
        If VScroll1.Visible = True Then
            If VScroll1.Value + ((Shift <> SHIFT_MASK) * VScroll1.SmallChange + (Shift = SHIFT_MASK) * VScroll1.LargeChange) < VScroll1.Min Then
                VScroll1.Value = VScroll1.Min
            Else
                VScroll1.Value = VScroll1.Value + ((Shift <> SHIFT_MASK) * VScroll1.SmallChange + (Shift = SHIFT_MASK) * VScroll1.LargeChange)
            End If
        End If
    Case KEY_DOWN
        If VScroll1.Visible = True Then
            If VScroll1.Value - ((Shift <> SHIFT_MASK) * VScroll1.SmallChange + (Shift = SHIFT_MASK) * VScroll1.LargeChange) > VScroll1.Max Then
                VScroll1.Value = VScroll1.Max
            Else
                VScroll1.Value = VScroll1.Value - ((Shift <> SHIFT_MASK) * VScroll1.SmallChange + (Shift = SHIFT_MASK) * VScroll1.LargeChange)
            End If
        End If
    End Select
End Sub

Sub Form_Load ()
    Select Case GetPrivateProfileInt("ChildWindow", "State", CHILDWINDOW_DEFAULT_STATE, APPLICATION_INI_NAME)
    Case NORMAL
        WindowState = NORMAL
    Case MINIMIZED
        WindowState = NORMAL
    Case MAXIMIZED
        WindowState = MAXIMIZED
    End Select
    
    'Form_LoadɔForm.Resizê߂ɕKv
    PicMain.Width = GetPrivateProfileSng("PicMain", "Width", PICMAIN_DEFAULT_WIDTH, APPLICATION_INI_NAME)
    PicMain.Height = GetPrivateProfileSng("PicMain", "Height", PICMAIN_DEFAULT_HEIGHT, APPLICATION_INI_NAME)
End Sub

Sub Form_Resize ()
    If ScaleHeight = 0 Then
        HScroll1.Visible = False
        VScroll1.Visible = False
        Picture1.Visible = False
        
        Exit Sub
    End If

    If ScaleHeight < HScroll1.Height Then
        HScroll1.Visible = False
        VScroll1.Visible = True
        Picture1.Visible = False
        
        VScroll1.Left = ScaleWidth - VScroll1.Width
        VScroll1.Height = ScaleHeight
        VScroll1.Max = PicMain.Height - ScaleHeight
        
        Exit Sub
    End If
        
    If PicMain.Width - (ScaleWidth - VScroll1.Width) < 1 Then
        PicMain.Left = 0
        If PicMain.Height - ScaleHeight < 1 Then
            PicMain.Top = 0
            HScroll1.Visible = False
            VScroll1.Visible = False
            Picture1.Visible = False
        Else
            HScroll1.Visible = False
            VScroll1.Visible = True
            Picture1.Visible = False
            
            VScroll1.Left = ScaleWidth - VScroll1.Width
            VScroll1.Height = ScaleHeight
            
            VScroll1.Max = PicMain.Height - ScaleHeight
        End If
        Exit Sub
    End If
    
    If PicMain.Height - (ScaleHeight - HScroll1.Height) < 1 Then
        PicMain.Top = 0
        If PicMain.Width - ScaleWidth < 1 Then
            PicMain.Left = 0
            HScroll1.Visible = False
            VScroll1.Visible = False
            Picture1.Visible = False
        Else
            HScroll1.Visible = True
            VScroll1.Visible = False
            Picture1.Visible = False
            
            HScroll1.Top = ScaleHeight - HScroll1.Height
            HScroll1.Width = ScaleWidth
            
            HScroll1.Max = PicMain.Width - ScaleWidth
        End If
        Exit Sub
    End If
    
    HScroll1.Visible = True
    VScroll1.Visible = True
    Picture1.Visible = True
    
    HScroll1.Top = ScaleHeight - HScroll1.Height
    VScroll1.Left = ScaleWidth - VScroll1.Width
    HScroll1.Width = ScaleWidth - VScroll1.Width
    VScroll1.Height = ScaleHeight - HScroll1.Height
    
    HScroll1.Max = PicMain.Width - (ScaleWidth - VScroll1.Width)
    VScroll1.Max = PicMain.Height - (ScaleHeight - HScroll1.Height)

    Picture1.Left = ScaleWidth - VScroll1.Width
    Picture1.Top = ScaleHeight - HScroll1.Height
End Sub

Sub Form_Unload (Cancel As Integer)
    Dim Ret As Integer
    
    WritePrivateFormSize Me
    
    FigureStatus(Tag).Closed = True
    MDIFrmMain.LblFigureCount.Caption = MDIFrmMain.LblFigureCount.Caption - 1
End Sub

Sub HScroll1_Change ()
    PicMain.Left = -HScroll1.Value
End Sub

Sub HScroll1_Scroll ()
    HScroll1_Change
End Sub

Sub PicMain_Change ()
    OriginX = GetPrivateProfileInt("PicMain", "OriginX", PICMAIN_DEFAULT_ORIGINX, APPLICATION_INI_NAME) * MM2TWIP
    OriginY = GetPrivateProfileInt("PicMain", "OriginY", PICMAIN_DEFAULT_ORIGINY, APPLICATION_INI_NAME) * MM2TWIP
    ZoomFactorX = GetPrivateProfileSng("PicMain", "ZoomFactorX", PICMAIN_DEFAULT_ZOOMFACTORX, APPLICATION_INI_NAME)
    ZoomFactorY = GetPrivateProfileSng("PicMain", "ZoomFactorY", PICMAIN_DEFAULT_ZOOMFACTORY, APPLICATION_INI_NAME)
End Sub

Sub PicMain_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = LEFT_BUTTON Then
        Rs_X = X
        Rs_Y = Y
        Region.Visible = False
    End If
End Sub

Sub PicMain_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = LEFT_BUTTON Then
        If GetPrivateProfileInt("Option", "MouseOperation", MOUSE_OPERATION_DEFAULT, APPLICATION_INI_NAME) = MOUSE_OPERATION_SCROLL Then
            PicMain.MousePointer = SIZE_POINTER
            S_PicMain_MouseMove_Scroll X, Y
        Else    '}EXŔ͈͎w
            PicMain.MousePointer = CROSSHAIR
            S_PicMain_MouseMove_Region X, Y
            
            MDIFrmMain.LblCoordinate.Caption = "I: (" + CStr(F_Get_Real_X(Rs_X)) + "," + CStr(F_Get_Real_Y(Rs_Y)) + ")" + "-(" + CStr(F_Get_Real_X(X)) + "," + CStr(F_Get_Real_Y(Y)) + ")" + "=(" + CStr(Abs(F_Get_Real_X(X) - F_Get_Real_X(Rs_X))) + "," + CStr(Abs(F_Get_Real_Y(Y) - F_Get_Real_Y((Rs_Y)))) + ")"
            Region.Visible = True
        End If
    Else
        PicMain.MousePointer = DEFAULT
        If Region.Visible = True Then
            MDIFrmMain.LblCoordinate.Caption = "I: (" + CStr(CLng(Region.Width / ZoomFactorX)) + "," + CStr(CLng(Region.Height / ZoomFactorY)) + ")"
            MDIFrmMain.MnuEditCopy.Caption = "I͈͂Rs[(&C&)"
        Else
            MDIFrmMain.LblCoordinate.Caption = "(" + CStr(F_Get_Real_X(X)) + "," + CStr(F_Get_Real_Y(Y)) + ")"
            MDIFrmMain.MnuEditCopy.Caption = "ŜRs[(&C&)"
        End If
    End If
End Sub

Sub PicMain_Resize ()
    Form_Resize
End Sub

'̃vV[WFrmFigurePicMainScaleModeƂ̂ݐɓ삷
Sub S_PicMain_MouseMove_Region (X As Single, Y As Single)
    Select Case X
    Case Is > Rs_X  'Eɓ
        If X > PicMain.ScaleLeft + PicMain.ScaleWidth Then
            X = PicMain.ScaleLeft + PicMain.ScaleWidth
            If Rs_X = PicMain.ScaleLeft + PicMain.ScaleWidth Then
                Rs_X = PicMain.ScaleLeft + PicMain.ScaleWidth - 1
            End If
        End If
        Region.Left = Rs_X
        Region.Width = X - Rs_X
    Case Is < Rs_X  'ɓ
        If X < PicMain.ScaleLeft Then
            X = PicMain.ScaleLeft
            If Rs_X = PicMain.ScaleLeft Then
                Rs_X = PicMain.ScaleLeft + 1
            End If
        End If
        Region.Left = X
        Region.Width = Rs_X - X
    End Select
    
    Select Case Y
    Case Is > Rs_Y  'ɓ
        If Y > PicMain.ScaleTop + PicMain.ScaleHeight Then
            Y = PicMain.ScaleTop + PicMain.ScaleHeight
            If Rs_Y = PicMain.ScaleTop + PicMain.ScaleHeight Then
                Rs_Y = PicMain.ScaleTop + PicMain.ScaleHeight + 1
            End If
        End If
        Region.Top = Rs_Y
        Region.Height = Y - Rs_Y
    Case Is < Rs_Y  'ɓ
        If Y < PicMain.ScaleTop Then
            Y = PicMain.ScaleTop
            If Rs_Y = PicMain.ScaleTop Then
                Rs_Y = PicMain.ScaleTop - 1
            End If
        End If
        Region.Top = Y
        Region.Height = Rs_Y - Y
    End Select
    
    '}EXɂI[gXN[
    Select Case X + PicMain.Left
    Case Is < -500
        Form_KeyDown KEY_LEFT, SHIFT_MASK
    Case -500 To 100
        Form_KeyDown KEY_LEFT, 0
    Case MDIFrmMain.ActiveForm.ScaleWidth - VScroll1.Width - 100 To MDIFrmMain.ActiveForm.ScaleWidth - VScroll1.Width + 500 'ڂĂPicMainڂĂtH[ŵ͓
        Form_KeyDown KEY_RIGHT, 0
    Case Is > MDIFrmMain.ActiveForm.ScaleWidth - VScroll1.Width + 500
        Form_KeyDown KEY_RIGHT, SHIFT_MASK
    End Select
    Select Case Y + PicMain.Top
    Case Is < -500
        Form_KeyDown KEY_UP, SHIFT_MASK
    Case -500 To 100
        Form_KeyDown KEY_UP, 0
    Case MDIFrmMain.ActiveForm.ScaleHeight - HScroll1.Height - 100 To MDIFrmMain.ActiveForm.ScaleHeight - HScroll1.Height + 500
        Form_KeyDown KEY_DOWN, 0
    Case Is > MDIFrmMain.ActiveForm.ScaleHeight - HScroll1.Height + 500
        Form_KeyDown KEY_DOWN, SHIFT_MASK
    End Select
End Sub

'̃vV[WFrmFigurePicMainScaleModeƂ̂ݐɓ삷
Sub S_PicMain_MouseMove_Scroll (X As Single, Y As Single)
    Dim TempValue As Single

    If HScroll1.Visible = True Then
        TempValue = HScroll1.Value - (X - Rs_X)
        Select Case TempValue
        Case Is < HScroll1.Min
            HScroll1.Value = HScroll1.Min
        Case Is > HScroll1.Max
            HScroll1.Value = HScroll1.Max
        Case Else
            HScroll1.Value = TempValue
        End Select
    End If
    
    If VScroll1.Visible = True Then
        TempValue = VScroll1.Value - (Y - Rs_Y)
        Select Case TempValue
        Case Is < VScroll1.Min
            VScroll1.Value = VScroll1.Min
        Case Is > VScroll1.Max
            VScroll1.Value = VScroll1.Max
        Case Else
            VScroll1.Value = TempValue
        End Select
    End If
End Sub

Sub VScroll1_Change ()
    PicMain.Top = -VScroll1.Value
End Sub

Sub VScroll1_Scroll ()
    VScroll1_Change
End Sub

