Option Explicit

Global Const RECENT_PATH_MAX = 5 '̐lf.MnuFileRecentPatȟƓɂ
Global RecentPath(RECENT_PATH_MAX) As String

Sub GetPrivateRecentPath (f As Form)
    Dim I As Integer

    For I = 0 To RECENT_PATH_MAX - 1
	RecentPath(I) = GetPrivateProfileStr("RecentPath", CStr(I), "", APPLICATION_INI_NAME)
    Next I
    RecentPath(RECENT_PATH_MAX) = ""
    
    RecentPathShow f
End Sub

Sub RecentPathRemove (f As Form, Path As String)
    Dim I As Integer, J As Integer

    For I = 0 To RECENT_PATH_MAX - 1
	If RecentPath(I) = Path Then
	    For J = I + 1 To RECENT_PATH_MAX
		RecentPath(J - 1) = RecentPath(J)
	    Next J
	    RecentPathShow f
	    Exit Sub
	End If
    Next I
End Sub

Sub RecentPathShow (f As Form)
    Dim I As Integer
    
    f.MnuFileRecentPathSepa.Visible = (RecentPath(0) <> "")
    For I = 0 To RECENT_PATH_MAX - 1
	f.MnuFileRecentPath(I).Caption = RecentPath(RECENT_PATH_MAX - I - 1)
	f.MnuFileRecentPath(I).Visible = (RecentPath(RECENT_PATH_MAX - I - 1) <> "")
    Next I
End Sub

Sub RecentPathStore (f As Form, Path As String)
    Dim I As Integer, J As Integer

    For I = 0 To RECENT_PATH_MAX - 1
	If RecentPath(I) = Path Then    'ɓǂ񂾂Ƃ
	    For J = I + 1 To RECENT_PATH_MAX
		If RecentPath(J) = "" Then
		    RecentPath(J - 1) = Path
		    RecentPathShow f
		    Exit Sub
		Else
		    RecentPath(J - 1) = RecentPath(J)
		End If
	    Next J
	End If
    Next I

    For I = 0 To RECENT_PATH_MAX - 1
	If RecentPath(I) = "" Then      '܂󂫂
	    RecentPath(I) = Path
	    RecentPathShow f
	    Exit Sub
	End If
    Next I

    For I = 0 To RECENT_PATH_MAX - 1    '󂫂Ȃ
	RecentPath(I) = RecentPath(I + 1)
    Next I
    RecentPath(RECENT_PATH_MAX - 1) = Path
    RecentPathShow f
End Sub

Sub WritePrivateRecentPath ()
    Dim Ret As Integer
    Dim I As Integer

    For I = 0 To RECENT_PATH_MAX - 1
	Ret = WritePrivateProfileStr("RecentPath", CStr(I), RecentPath(I), APPLICATION_INI_NAME)
    Next I
End Sub

